/**
* user:  B1002
* fname: Konstantin
* lname: Kamenov
* task:  Cnet
* score: 35.0
* date:  2017-11-24 12:08:04.647356
*/
#include<iostream>
#define cline std::cout<<__LINE__
int matrix[1600][1600];
bool visited[1600];
bool visited2[1600];
int n,m;
bool back=0;
void dfcycle(int node,int target,bool s){
    if(back){
        return;
    }
    if(node==target && !s){
        back=1;
        return;
    }
    visited2[node]=1;
    for(int i=0;i<n;i++){
        if(!visited2[i] && matrix[node][i]>1){
            dfcycle(i,target,0);
        }
    }
}
bool isok(int node){
    for(int i=0;i<n;i++){
        if(matrix[node][i]==1){
            for(int j=0;j<n;j++){
                visited2[j]=0;
            }
            back=0;
            dfcycle(node,node,0);
            return back;
        }
    }
    return true;
}
int ends=0;
int overlord;
bool changed;
void dfs(int node){
    visited[node]=1;
    bool ending=1;
    if(matrix[node][overlord]>1){
        ending=0;
    }
    for(int i=0;i<n;i++){
        if(!visited[i] && matrix[node][i]!=0){
            dfs(i);
            ending=0;
        }
    }
    changed|=ending;
    ends+=ending;
}
int main(){
    std::cin>>n>>m;
    int a,b;
    for(int i=0;i<m;i++){
        std::cin>>a>>b;
        matrix[a][b]|=2;
        matrix[b][a]|=1;
    }
    int ans=0;
    for(int i=0;i<n;i++){
        if(!visited[i] && isok(i)){
            ans++;
            //cline;
            overlord=i;
            changed=0;
            dfs(i);
            ends+=!changed;
            //cline;
        }
    }
    std::cout<<ans<<" "<<ends<<std::endl;
    return 0;
}
